package com.wuban.tron.explore.entity.example;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 区块交易信息表 查询条件example类
 * @author sky
 * @date 2020-11-06
 */
public class TransactionExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TransactionExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

	        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria)this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria)this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria)this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria)this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria)this;
        }
		
		public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria)this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria)this;
        }
			
	            public Criteria andBlockIdIsNull() {
            addCriterion("block_id is null");
            return (Criteria)this;
        }

        public Criteria andBlockIdIsNotNull() {
            addCriterion("block_id is not null");
            return (Criteria)this;
        }

        public Criteria andBlockIdEqualTo(String value) {
            addCriterion("block_id =", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotEqualTo(String value) {
            addCriterion("block_id <>", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdIn(List<String> values) {
            addCriterion("block_id in", values, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotIn(List<String> values) {
            addCriterion("block_id not in", values, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdBetween(String value1, String value2) {
            addCriterion("block_id between", value1, value2, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotBetween(String value1, String value2) {
            addCriterion("block_id not between", value1, value2, "blockId");
            return (Criteria)this;
        }
		
			
		public Criteria andBlockIdLike(String value) {
            addCriterion("block_id like", value, "blockId");
            return (Criteria)this;
        }

        public Criteria andBlockIdNotLike(String value) {
            addCriterion("block_id not like", value, "blockId");
            return (Criteria)this;
        }
	            public Criteria andTxIdIsNull() {
            addCriterion("tx_id is null");
            return (Criteria)this;
        }

        public Criteria andTxIdIsNotNull() {
            addCriterion("tx_id is not null");
            return (Criteria)this;
        }

        public Criteria andTxIdEqualTo(String value) {
            addCriterion("tx_id =", value, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdNotEqualTo(String value) {
            addCriterion("tx_id <>", value, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdIn(List<String> values) {
            addCriterion("tx_id in", values, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdNotIn(List<String> values) {
            addCriterion("tx_id not in", values, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdBetween(String value1, String value2) {
            addCriterion("tx_id between", value1, value2, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdNotBetween(String value1, String value2) {
            addCriterion("tx_id not between", value1, value2, "txId");
            return (Criteria)this;
        }
		
			
		public Criteria andTxIdLike(String value) {
            addCriterion("tx_id like", value, "txId");
            return (Criteria)this;
        }

        public Criteria andTxIdNotLike(String value) {
            addCriterion("tx_id not like", value, "txId");
            return (Criteria)this;
        }
	            public Criteria andContractRetIsNull() {
            addCriterion("contract_ret is null");
            return (Criteria)this;
        }

        public Criteria andContractRetIsNotNull() {
            addCriterion("contract_ret is not null");
            return (Criteria)this;
        }

        public Criteria andContractRetEqualTo(String value) {
            addCriterion("contract_ret =", value, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetNotEqualTo(String value) {
            addCriterion("contract_ret <>", value, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetIn(List<String> values) {
            addCriterion("contract_ret in", values, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetNotIn(List<String> values) {
            addCriterion("contract_ret not in", values, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetBetween(String value1, String value2) {
            addCriterion("contract_ret between", value1, value2, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetNotBetween(String value1, String value2) {
            addCriterion("contract_ret not between", value1, value2, "contractRet");
            return (Criteria)this;
        }
		
			
		public Criteria andContractRetLike(String value) {
            addCriterion("contract_ret like", value, "contractRet");
            return (Criteria)this;
        }

        public Criteria andContractRetNotLike(String value) {
            addCriterion("contract_ret not like", value, "contractRet");
            return (Criteria)this;
        }
	            public Criteria andOwnerAddressIsNull() {
            addCriterion("owner_address is null");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressIsNotNull() {
            addCriterion("owner_address is not null");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressEqualTo(String value) {
            addCriterion("owner_address =", value, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressNotEqualTo(String value) {
            addCriterion("owner_address <>", value, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressIn(List<String> values) {
            addCriterion("owner_address in", values, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressNotIn(List<String> values) {
            addCriterion("owner_address not in", values, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressBetween(String value1, String value2) {
            addCriterion("owner_address between", value1, value2, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressNotBetween(String value1, String value2) {
            addCriterion("owner_address not between", value1, value2, "ownerAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andOwnerAddressLike(String value) {
            addCriterion("owner_address like", value, "ownerAddress");
            return (Criteria)this;
        }

        public Criteria andOwnerAddressNotLike(String value) {
            addCriterion("owner_address not like", value, "ownerAddress");
            return (Criteria)this;
        }
	            public Criteria andDataIsNull() {
            addCriterion("data is null");
            return (Criteria)this;
        }

        public Criteria andDataIsNotNull() {
            addCriterion("data is not null");
            return (Criteria)this;
        }

        public Criteria andDataEqualTo(String value) {
            addCriterion("data =", value, "data");
            return (Criteria)this;
        }

        public Criteria andDataNotEqualTo(String value) {
            addCriterion("data <>", value, "data");
            return (Criteria)this;
        }

        public Criteria andDataIn(List<String> values) {
            addCriterion("data in", values, "data");
            return (Criteria)this;
        }

        public Criteria andDataNotIn(List<String> values) {
            addCriterion("data not in", values, "data");
            return (Criteria)this;
        }

        public Criteria andDataBetween(String value1, String value2) {
            addCriterion("data between", value1, value2, "data");
            return (Criteria)this;
        }

        public Criteria andDataNotBetween(String value1, String value2) {
            addCriterion("data not between", value1, value2, "data");
            return (Criteria)this;
        }
		
			
		public Criteria andDataLike(String value) {
            addCriterion("data like", value, "data");
            return (Criteria)this;
        }

        public Criteria andDataNotLike(String value) {
            addCriterion("data not like", value, "data");
            return (Criteria)this;
        }
	            public Criteria andContractAddressIsNull() {
            addCriterion("contract_address is null");
            return (Criteria)this;
        }

        public Criteria andContractAddressIsNotNull() {
            addCriterion("contract_address is not null");
            return (Criteria)this;
        }

        public Criteria andContractAddressEqualTo(String value) {
            addCriterion("contract_address =", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotEqualTo(String value) {
            addCriterion("contract_address <>", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressIn(List<String> values) {
            addCriterion("contract_address in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotIn(List<String> values) {
            addCriterion("contract_address not in", values, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressBetween(String value1, String value2) {
            addCriterion("contract_address between", value1, value2, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotBetween(String value1, String value2) {
            addCriterion("contract_address not between", value1, value2, "contractAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andContractAddressLike(String value) {
            addCriterion("contract_address like", value, "contractAddress");
            return (Criteria)this;
        }

        public Criteria andContractAddressNotLike(String value) {
            addCriterion("contract_address not like", value, "contractAddress");
            return (Criteria)this;
        }
	            public Criteria andAmountIsNull() {
            addCriterion("amount is null");
            return (Criteria)this;
        }

        public Criteria andAmountIsNotNull() {
            addCriterion("amount is not null");
            return (Criteria)this;
        }

        public Criteria andAmountEqualTo(Long value) {
            addCriterion("amount =", value, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountNotEqualTo(Long value) {
            addCriterion("amount <>", value, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountIn(List<Long> values) {
            addCriterion("amount in", values, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountNotIn(List<Long> values) {
            addCriterion("amount not in", values, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountBetween(Long value1, Long value2) {
            addCriterion("amount between", value1, value2, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountNotBetween(Long value1, Long value2) {
            addCriterion("amount not between", value1, value2, "amount");
            return (Criteria)this;
        }
		
		public Criteria andAmountGreaterThan(Long value) {
            addCriterion("amount >", value, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountGreaterThanOrEqualTo(Long value) {
            addCriterion("amount >=", value, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountLessThan(Long value) {
            addCriterion("amount <", value, "amount");
            return (Criteria)this;
        }

        public Criteria andAmountLessThanOrEqualTo(Long value) {
            addCriterion("amount <=", value, "amount");
            return (Criteria)this;
        }
			
	            public Criteria andToAddressIsNull() {
            addCriterion("to_address is null");
            return (Criteria)this;
        }

        public Criteria andToAddressIsNotNull() {
            addCriterion("to_address is not null");
            return (Criteria)this;
        }

        public Criteria andToAddressEqualTo(String value) {
            addCriterion("to_address =", value, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressNotEqualTo(String value) {
            addCriterion("to_address <>", value, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressIn(List<String> values) {
            addCriterion("to_address in", values, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressNotIn(List<String> values) {
            addCriterion("to_address not in", values, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressBetween(String value1, String value2) {
            addCriterion("to_address between", value1, value2, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressNotBetween(String value1, String value2) {
            addCriterion("to_address not between", value1, value2, "toAddress");
            return (Criteria)this;
        }
		
			
		public Criteria andToAddressLike(String value) {
            addCriterion("to_address like", value, "toAddress");
            return (Criteria)this;
        }

        public Criteria andToAddressNotLike(String value) {
            addCriterion("to_address not like", value, "toAddress");
            return (Criteria)this;
        }
	            public Criteria andTypeUrlIsNull() {
            addCriterion("type_url is null");
            return (Criteria)this;
        }

        public Criteria andTypeUrlIsNotNull() {
            addCriterion("type_url is not null");
            return (Criteria)this;
        }

        public Criteria andTypeUrlEqualTo(String value) {
            addCriterion("type_url =", value, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlNotEqualTo(String value) {
            addCriterion("type_url <>", value, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlIn(List<String> values) {
            addCriterion("type_url in", values, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlNotIn(List<String> values) {
            addCriterion("type_url not in", values, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlBetween(String value1, String value2) {
            addCriterion("type_url between", value1, value2, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlNotBetween(String value1, String value2) {
            addCriterion("type_url not between", value1, value2, "typeUrl");
            return (Criteria)this;
        }
		
			
		public Criteria andTypeUrlLike(String value) {
            addCriterion("type_url like", value, "typeUrl");
            return (Criteria)this;
        }

        public Criteria andTypeUrlNotLike(String value) {
            addCriterion("type_url not like", value, "typeUrl");
            return (Criteria)this;
        }
	            public Criteria andTypeIsNull() {
            addCriterion("type is null");
            return (Criteria)this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("type is not null");
            return (Criteria)this;
        }

        public Criteria andTypeEqualTo(String value) {
            addCriterion("type =", value, "type");
            return (Criteria)this;
        }

        public Criteria andTypeNotEqualTo(String value) {
            addCriterion("type <>", value, "type");
            return (Criteria)this;
        }

        public Criteria andTypeIn(List<String> values) {
            addCriterion("type in", values, "type");
            return (Criteria)this;
        }

        public Criteria andTypeNotIn(List<String> values) {
            addCriterion("type not in", values, "type");
            return (Criteria)this;
        }

        public Criteria andTypeBetween(String value1, String value2) {
            addCriterion("type between", value1, value2, "type");
            return (Criteria)this;
        }

        public Criteria andTypeNotBetween(String value1, String value2) {
            addCriterion("type not between", value1, value2, "type");
            return (Criteria)this;
        }
		
			
		public Criteria andTypeLike(String value) {
            addCriterion("type like", value, "type");
            return (Criteria)this;
        }

        public Criteria andTypeNotLike(String value) {
            addCriterion("type not like", value, "type");
            return (Criteria)this;
        }
	            public Criteria andRefBlockBytesIsNull() {
            addCriterion("ref_block_bytes is null");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesIsNotNull() {
            addCriterion("ref_block_bytes is not null");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesEqualTo(String value) {
            addCriterion("ref_block_bytes =", value, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesNotEqualTo(String value) {
            addCriterion("ref_block_bytes <>", value, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesIn(List<String> values) {
            addCriterion("ref_block_bytes in", values, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesNotIn(List<String> values) {
            addCriterion("ref_block_bytes not in", values, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesBetween(String value1, String value2) {
            addCriterion("ref_block_bytes between", value1, value2, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesNotBetween(String value1, String value2) {
            addCriterion("ref_block_bytes not between", value1, value2, "refBlockBytes");
            return (Criteria)this;
        }
		
			
		public Criteria andRefBlockBytesLike(String value) {
            addCriterion("ref_block_bytes like", value, "refBlockBytes");
            return (Criteria)this;
        }

        public Criteria andRefBlockBytesNotLike(String value) {
            addCriterion("ref_block_bytes not like", value, "refBlockBytes");
            return (Criteria)this;
        }
	            public Criteria andRefBlockHashIsNull() {
            addCriterion("ref_block_hash is null");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashIsNotNull() {
            addCriterion("ref_block_hash is not null");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashEqualTo(String value) {
            addCriterion("ref_block_hash =", value, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashNotEqualTo(String value) {
            addCriterion("ref_block_hash <>", value, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashIn(List<String> values) {
            addCriterion("ref_block_hash in", values, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashNotIn(List<String> values) {
            addCriterion("ref_block_hash not in", values, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashBetween(String value1, String value2) {
            addCriterion("ref_block_hash between", value1, value2, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashNotBetween(String value1, String value2) {
            addCriterion("ref_block_hash not between", value1, value2, "refBlockHash");
            return (Criteria)this;
        }
		
			
		public Criteria andRefBlockHashLike(String value) {
            addCriterion("ref_block_hash like", value, "refBlockHash");
            return (Criteria)this;
        }

        public Criteria andRefBlockHashNotLike(String value) {
            addCriterion("ref_block_hash not like", value, "refBlockHash");
            return (Criteria)this;
        }
	            public Criteria andExpirationIsNull() {
            addCriterion("expiration is null");
            return (Criteria)this;
        }

        public Criteria andExpirationIsNotNull() {
            addCriterion("expiration is not null");
            return (Criteria)this;
        }

        public Criteria andExpirationEqualTo(Long value) {
            addCriterion("expiration =", value, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationNotEqualTo(Long value) {
            addCriterion("expiration <>", value, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationIn(List<Long> values) {
            addCriterion("expiration in", values, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationNotIn(List<Long> values) {
            addCriterion("expiration not in", values, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationBetween(Long value1, Long value2) {
            addCriterion("expiration between", value1, value2, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationNotBetween(Long value1, Long value2) {
            addCriterion("expiration not between", value1, value2, "expiration");
            return (Criteria)this;
        }
		
		public Criteria andExpirationGreaterThan(Long value) {
            addCriterion("expiration >", value, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationGreaterThanOrEqualTo(Long value) {
            addCriterion("expiration >=", value, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationLessThan(Long value) {
            addCriterion("expiration <", value, "expiration");
            return (Criteria)this;
        }

        public Criteria andExpirationLessThanOrEqualTo(Long value) {
            addCriterion("expiration <=", value, "expiration");
            return (Criteria)this;
        }
			
	            public Criteria andFeeLimitIsNull() {
            addCriterion("fee_limit is null");
            return (Criteria)this;
        }

        public Criteria andFeeLimitIsNotNull() {
            addCriterion("fee_limit is not null");
            return (Criteria)this;
        }

        public Criteria andFeeLimitEqualTo(Long value) {
            addCriterion("fee_limit =", value, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitNotEqualTo(Long value) {
            addCriterion("fee_limit <>", value, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitIn(List<Long> values) {
            addCriterion("fee_limit in", values, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitNotIn(List<Long> values) {
            addCriterion("fee_limit not in", values, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitBetween(Long value1, Long value2) {
            addCriterion("fee_limit between", value1, value2, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitNotBetween(Long value1, Long value2) {
            addCriterion("fee_limit not between", value1, value2, "feeLimit");
            return (Criteria)this;
        }
		
		public Criteria andFeeLimitGreaterThan(Long value) {
            addCriterion("fee_limit >", value, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitGreaterThanOrEqualTo(Long value) {
            addCriterion("fee_limit >=", value, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitLessThan(Long value) {
            addCriterion("fee_limit <", value, "feeLimit");
            return (Criteria)this;
        }

        public Criteria andFeeLimitLessThanOrEqualTo(Long value) {
            addCriterion("fee_limit <=", value, "feeLimit");
            return (Criteria)this;
        }
			
	            public Criteria andTimestampIsNull() {
            addCriterion("timestamp is null");
            return (Criteria)this;
        }

        public Criteria andTimestampIsNotNull() {
            addCriterion("timestamp is not null");
            return (Criteria)this;
        }

        public Criteria andTimestampEqualTo(Long value) {
            addCriterion("timestamp =", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotEqualTo(Long value) {
            addCriterion("timestamp <>", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampIn(List<Long> values) {
            addCriterion("timestamp in", values, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotIn(List<Long> values) {
            addCriterion("timestamp not in", values, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampBetween(Long value1, Long value2) {
            addCriterion("timestamp between", value1, value2, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampNotBetween(Long value1, Long value2) {
            addCriterion("timestamp not between", value1, value2, "timestamp");
            return (Criteria)this;
        }
		
		public Criteria andTimestampGreaterThan(Long value) {
            addCriterion("timestamp >", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampGreaterThanOrEqualTo(Long value) {
            addCriterion("timestamp >=", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampLessThan(Long value) {
            addCriterion("timestamp <", value, "timestamp");
            return (Criteria)this;
        }

        public Criteria andTimestampLessThanOrEqualTo(Long value) {
            addCriterion("timestamp <=", value, "timestamp");
            return (Criteria)this;
        }
			
	            public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria)this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria)this;
        }
		
		public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria)this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria)this;
        }
			
	            public Criteria andNumberIsNull() {
            addCriterion("number is null");
            return (Criteria)this;
        }

        public Criteria andNumberIsNotNull() {
            addCriterion("number is not null");
            return (Criteria)this;
        }

        public Criteria andNumberEqualTo(Long value) {
            addCriterion("number =", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotEqualTo(Long value) {
            addCriterion("number <>", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberIn(List<Long> values) {
            addCriterion("number in", values, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotIn(List<Long> values) {
            addCriterion("number not in", values, "number");
            return (Criteria)this;
        }

        public Criteria andNumberBetween(Long value1, Long value2) {
            addCriterion("number between", value1, value2, "number");
            return (Criteria)this;
        }

        public Criteria andNumberNotBetween(Long value1, Long value2) {
            addCriterion("number not between", value1, value2, "number");
            return (Criteria)this;
        }
		
		public Criteria andNumberGreaterThan(Long value) {
            addCriterion("number >", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberGreaterThanOrEqualTo(Long value) {
            addCriterion("number >=", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberLessThan(Long value) {
            addCriterion("number <", value, "number");
            return (Criteria)this;
        }

        public Criteria andNumberLessThanOrEqualTo(Long value) {
            addCriterion("number <=", value, "number");
            return (Criteria)this;
        }
			
	    	public Criteria andFieldIsNull(final String fieldName) {
            addCriterion(fieldName + " is null");
            return (Criteria) this;
        }
		
	public Criteria andFieldIsNotNull(final String fieldName) {
            addCriterion(fieldName + " is not null");
            return (Criteria) this;
        }
		
	public Criteria andFieldEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " = ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <> ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " in ", values, fieldName);
           return (Criteria) this;
        }
		
	public Criteria andFieldNotIn(final String fieldName, final List<Object> values) {
            addCriterion(fieldName + " not in ", values, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + " between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotBetween(final String fieldName, final Object fieldValue1,final Object fieldValue2) {
            addCriterion(fieldName + "  not between ", fieldValue1, fieldValue2, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldGreaterThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " > ", fieldValue, fieldName);
            return (Criteria) this;
        }

	public Criteria andFieldGreaterThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " >= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLessThan(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " < ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
		public Criteria andFieldLessThanOrEqualTo(final String fieldName, final Object fieldValue) {
            addCriterion(fieldName + " <= ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + " like ", fieldValue, fieldName);
            return (Criteria) this;
        }
		
	public Criteria andFieldNotLike(final String fieldName, final String fieldValue) {
            addCriterion(fieldName + "  not like ", fieldValue, fieldName);
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}
